//+------------------------------------------------------------------+
//|                                                tsd_4hrs_try1.mq4 |
//|                               
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, NazFunds Company"
#property link      "http://www.nazfunds.com"
#include <stdlib.mqh>

extern double lots         = 0.1;           // 
extern double trailingStop = 15;            // trail stop in points
extern double takeProfit   = 20;            // recomended  no more than 20
extern double stopLoss     = 0;             // do not use s/l
extern double slippage     = 3;             // Could be higher with some brokers
extern string nameEA       = "dt";  // To "easy read" which EA place an specific order
extern int magicEA         = 19000;         // Magic EA identifier. Allows for several co-existing EA with different input values

double long_ma, short_ma, macdHistCurrent, macdHistPrevious, macdSignalCurrent, macdSignalPrevious;
double stochHistCurrent, stochHistPrevious, stochSignalCurrent, stochSignalPrevious;
double sarCurrent, sarPrevious, momCurrent, momPrevious,x,y;
double realTP, realSL;
bool isBuying = false, isSelling = false, isClosing = false, sell_trade_again = false, buy_trade_again = false; 
bool sell_trade_Again = false;
int cnt, ticket;
static datetime lasttt = 0;
static int numberofbuys, numberofsells;
static bool firstbuycheck, firstsellcheck;
static double firstbuysl, firstsellsl, firstbuyprice, firstsellprice;
static double lasttradeprice = 0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   // Check for invalid bars and takeprofit
   
     if ( Period()  == 1 )
   {
      nameEA = "dt-m1";
      magicEA = 19000;
   }   
   if ( Period()  == 5 )
   {
      nameEA = "dt-m5";
      magicEA = 19000 + 5;
   }
   if ( Period()  == 15 )
   {
      nameEA = "dt-m15";
      magicEA = 19000 + 15;
   }
   if ( Period()  == 30 )
   {
      nameEA = "dt-m30";
      magicEA = 19000 + 30;
   }   
   if ( Period()  == 60 )
   {
      nameEA = "dt-H1";
      magicEA = 19000 + 60;
   }   
   if ( Period()  == 240 )
   {
      nameEA = "dt-H4";
      magicEA = 19000 + 240;
   }      
   if ( Period()  == 1400 )
   {
      nameEA = "dt-Daily";
      magicEA = 19000 + 1440;
   }         
   if ( Period()  == 10080 )
   {
      nameEA = "dt-Weekly";
      magicEA = 19000 + 10080;
   }            
   if ( Period()  == 43200 )
   {
      nameEA = "dt-Monthly";
      magicEA = 19000 + 43200;
   }               
                  
   if(Bars < 200) {
      Print("Not enough bars for this strategy - ", nameEA);
      return(0);
   }
   calculateIndicators();                      // Calculate indicators' value   
   
   // Control open trades
   int totalOrders = OrdersTotal();
   int numPos = 0;
      
   for(cnt=0; cnt<totalOrders; cnt++) {        // scan all orders and positions...
      OrderSelect(cnt, SELECT_BY_POS);         // the next line will check for ONLY market trades, not entry orders
      if(OrderSymbol() == Symbol() && OrderType() <= OP_SELL && OrderMagicNumber() == magicEA) {   // only look for this symbol, and only orders from this EA      
         numPos++;
         if(OrderType() == OP_BUY) {           // Check for close signal for bought trade
            if(isSelling || isClosing) {
               OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Violet);   // Close bought trade
               prtAlert("Day Trading: Closing BUY order");
               numberofbuys = numberofbuys - 1;
               if (numberofbuys == 0) {
                 firstbuycheck = false; 
                 }
            }         
            if(trailingStop > 0) {             // Check trailing stop
               if(Bid-OrderOpenPrice() > trailingStop*Point) {
                  if(OrderStopLoss() < (Bid - trailingStop*Point)) {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-trailingStop*Point,OrderTakeProfit(),0,Blue);
                     prtAlert("Day Trading: Modifying BUY order");
                  }
               }
            }
         } else {                              // Check sold trade for close signal
            if(isBuying || isClosing) {
               OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Violet);
               prtAlert("Day Trading: Closing SELL order");
               numberofsells = numberofsells - 1;
               if (numberofsells == 0) {
                 firstsellcheck = false;
                 }
            }
            if(trailingStop > 0) {             // Control trailing stop
               if(OrderOpenPrice() - Ask > trailingStop*Point) {
                  if(OrderStopLoss() == 0 || OrderStopLoss() > Ask + trailingStop*Point) {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+trailingStop*Point,OrderTakeProfit(),0,Red);
                     prtAlert("Day Trading: Modifying SELL order");
                  }
               }           
            } 
         }
      }
   }
   
   //if price has moved in your direction by more then half of trailing stop
   //enter again in same dirction
   //for buys
   
  // buy_trade_again = false;
   //sell_trade_again = false;
   
   if (firstbuycheck == true) {
    x = ((Bid + Ask)/2)- lasttradeprice;
    y = (trailingStop/2)*Point;
    if(x>y){
      buy_trade_again = true;
    }//if(y>x)
   }//if (firstbuycheck == true)
   
   //for sells
   if (firstsellcheck == true) {
   x = lasttradeprice - ((Bid + Ask)/2);
   y = (trailingStop/2)*Point;
     if (x>y){
       sell_trade_again = true;
       
     }
   }
   
   
   if(firstbuycheck == false || firstsellcheck == false || sell_trade_again == true || buy_trade_again == true){  //todo: put a price diff in here
      if(AccountFreeMargin() < 1000*lots) {
         Print("Not enough money to trade ", lots, " lots. Strategy:", nameEA);
         return(0);
      }
      if((isBuying && !isSelling && !isClosing) == true || buy_trade_again == true) {  // Check for BUY entry signal
         if(stopLoss > 0)
            realSL = Ask - stopLoss * Point;
         if(takeProfit > 0)
            realTP = Ask + takeProfit * Point;
         ticket = OrderSend(Symbol(),OP_BUY,lots,Ask,slippage,realSL,realTP,nameEA+" - Magic: "+magicEA+" ",magicEA,0,Red);  // Buy
         if(ticket < 0) {
            Print("OrderSend (" + nameEA + ") failed with error #" + GetLastError() + " --> " + ErrorDescription(GetLastError()));
         } else {
            prtAlert("Day Trading: Buying"); 
            numberofbuys = numberofbuys +1;
            lasttt = CurTime();
            lasttradeprice = Ask;
            if (numberofbuys ==1){
              firstbuysl = realSL;
              firstbuyprice = Ask;
              firstbuycheck = true;}
         }
      }
      if((isSelling && !isBuying && !isClosing) == true || sell_trade_again == true) {  // Check for SELL entry signal
         if(stopLoss > 0)
            realSL = Bid + stopLoss * Point;
         if(takeProfit > 0)
            realTP = Bid - takeProfit * Point;
         ticket = OrderSend(Symbol(),OP_SELL,lots,Bid,slippage,realSL,realTP,nameEA+" - Magic: "+magicEA+" ",magicEA,0,Red); // Sell
         if(ticket < 0) {
            Print("OrderSend (" + nameEA + ") failed with error #" + GetLastError() + " --> " + ErrorDescription(GetLastError()));
         } else {
            prtAlert("Day Trading: Selling"); 
            numberofsells = numberofsells +1;
            lasttt = CurTime();
            lasttradeprice = Bid;
            if (numberofsells ==1){
              firstsellsl = realSL;
              firstsellprice = Ask;
              firstsellcheck = true;}
         }
      }
   }
   return(0);
}

void calculateIndicators() {    // Calculate indicators' value   
   
  macdHistCurrent     = iMACD(NULL,0,12,26,9,PRICE_OPEN,MODE_MAIN,0);   
   macdHistPrevious    = iMACD(NULL,0,12,26,9,PRICE_OPEN,MODE_MAIN,1);   
   macdSignalCurrent   = iMACD(NULL,0,12,26,9,PRICE_OPEN,MODE_SIGNAL,0); 
   macdSignalPrevious  = iMACD(NULL,0,12,26,9,PRICE_OPEN,MODE_SIGNAL,1); 
   stochHistCurrent    = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,0);
   stochHistPrevious   = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,1);
   stochSignalCurrent  = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,0);
   stochSignalPrevious = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,1);
   sarCurrent          = iSAR(NULL,0,0.02,0.2,0);           // Parabolic Sar Current
   sarPrevious         = iSAR(NULL,0,0.02,0.2,1);           // Parabolic Sar Previuos
   momCurrent          = iMomentum(NULL,0,14,PRICE_OPEN,0); // Momentum Current
   momPrevious         = iMomentum(NULL,0,14,PRICE_OPEN,1); // Momentum Previous
   
   // Check for BUY, SELL, and CLOSE signal
   isBuying  = (sarCurrent<=Ask && sarPrevious>sarCurrent && momCurrent<100 && macdHistCurrent<macdSignalCurrent && stochHistCurrent<35);
   isSelling = (sarCurrent>=Bid && sarPrevious<sarCurrent && momCurrent>100 && macdHistCurrent>macdSignalCurrent && stochHistCurrent>60);
   isClosing = false;
   
     if (firstbuycheck) {
    if (Bid < firstbuysl) {
      isClosing = true;
      return(0);
      }//if (bid < firstsl)
    if(stopLoss > 0)
       if(Bid-firstbuyprice > trailingStop*Point) {
        if(firstbuysl < (Bid - trailingStop*Point)) {     
            firstbuysl = Bid-trailingStop*Point;    
    }//if(firstsl < (Bid - trailingStop*Point))
   
     }//if(Bid-firstbuyprice > trailingStop*Point)  
}//if (firstbycheck && isbuying)   

if (firstsellcheck) {
    if (Bid> firstsellsl) {
     isClosing  = true;
     return(0);}//if (bid> firstsellsl)
    
  if(trailingStop > 0) { // Control trailing stop
     if(firstsellprice - Ask > trailingStop*Point) {
          if(firstsellsl == 0 || firstsellsl > Ask + trailingStop*Point) {
              firstsellsl = Ask+trailingStop*Point;}}}
                
  }//if (firstsellcheck)  
   
}

void prtAlert(string str = "") {
   Print(Symbol() + " - " + str);
   Alert(Symbol() + " - " + str);
   SpeechText(addSpaces(Symbol()) + " - " + str,SPEECH_ENGLISH);
   // SendMail(Symbol(),str);
}

string addSpaces(string str = "") {
   int length = StringLen(str);
   string sp  = "";
   for(int i=0; i<length; i++)
      sp = sp + StringSubstr(str,i,1) + " ";
   return (sp);
}
//+------------------------------------------------------------------+